#include "StdAfx.h"
#include "SMSController.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"
#include "WorkGroupModel.h"
#include "SMSSendWnd.h"

CSMSController::CSMSController(CSMSSendWnd* wnd)
{
	m_pSMSSendWnd = wnd;
}

CSMSController::~CSMSController(void)
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);

}

BOOL CSMSController::FindTelInSMSWnd(CString strTelNumber){
	BOOL bFound = FALSE;
	for (std::vector<CSMSModel::SMSReceiverInfo>::iterator it = m_SMSModel.m_receiverVector.begin(); it !=m_SMSModel.m_receiverVector.end();it ++ )
	{
		CString strCellPhone = (*it).strCellPhone;
		strCellPhone.Remove('-');
		strCellPhone.Remove('+');

		strTelNumber.Remove('-');
		strTelNumber.Remove('+');
		if (strCellPhone.CompareNoCase(strTelNumber) == 0)
		{
			bFound = TRUE;
			break;
		}
	}
	return bFound;
}

bool CSMSController::AddSMSReceiver( CString strUserID, CString strUserName, CString strTelNumber )
{
	bool bReturn = false;
	CSMSModel::SMSReceiverInfo ri;
	ri.strID = strUserID;
	ri.strName = strUserName;
	strTelNumber.Remove('-');
	strTelNumber.Remove('+');
	if (L""==strTelNumber)
	{
		return false;
	}

	ri.strCellPhone = strTelNumber;
	
    bool bFound = false;
	for (std::vector<CSMSModel::SMSReceiverInfo>::iterator it = m_SMSModel.m_receiverVector.begin(); it !=m_SMSModel.m_receiverVector.end();it ++ )
	{
		if ((*it).strCellPhone.CompareNoCase(strTelNumber) == 0)
		{
           bFound = true;
		   break;
		}
	}
	if (false == bFound )
	{
	    m_SMSModel.m_receiverVector.push_back(ri);
		bReturn = true;
	}
	return bReturn;
}

void CSMSController::RemoveSMSReceiver( CString strUserID )
{
	CSMSModel::SMSReceiverInfo find;
	find.strID = strUserID;
	std::vector<CSMSModel::SMSReceiverInfo>::const_iterator receiverInfoInterator = std::find(m_SMSModel.m_receiverVector.begin(), m_SMSModel.m_receiverVector.end(), find);

	if (receiverInfoInterator != m_SMSModel.m_receiverVector.end())
	{
		m_SMSModel.m_receiverVector.erase(receiverInfoInterator);
	}
	else
	{
		ASSERT(FALSE);
	}
}



CString CSMSController::GetReceiverTelNums()
{
	CString strReturn;
	for( std::vector<CSMSModel::SMSReceiverInfo>::const_iterator iter = m_SMSModel.m_receiverVector.begin(); iter != m_SMSModel.m_receiverVector.end(); ++iter )
	{
		if (m_SMSModel.m_receiverVector.size() == 1)
			strReturn.AppendFormat(L"%s",iter->strCellPhone);
		else
			strReturn.AppendFormat(L"%s,",iter->strCellPhone);
		
	}
	return strReturn;

}

LRESULT CSMSController::IsEnableReceiverUserCount( int nCount )
{
	LRESULT res = 0L;
	if (nCount>50)
	{
		res = 1L;
	}
	return res;
}

int CSMSController::Save()
{
	CSingleLock lock(&m_csLock, TRUE);	

	CString strPath;
	strPath.Format(_T("%s\\recentSmsRecv.dat"), GET_APP()->GetAppDataDir());

	CStdioFile file;
	if (file.Open(strPath, CFile::modeCreate|CFile::modeWrite) == 0)
	{
		return -1;
	}

    CString strReturn;
	for( std::vector<CSMSModel::SMSReceiverInfo>::const_iterator iter = m_SMSModel.m_recentReceiverVector.begin(); 
		iter != m_SMSModel.m_recentReceiverVector.end(); ++iter )
	{
	
			strReturn.AppendFormat(L"%s,%s\n",iter->strID,iter->strCellPhone);
			file.WriteString(strReturn);

	}
	

	file.Close();
	return 0;
}

bool CSMSController::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, 
														  GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list,
														  NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{

	/*if (m_trid != trid)
		return true;*/

	if (eErrorCode != wasError_None)
		return false;

	if (list.nSize <= 0)
		return false;
	GT_MY_USER_DATA MyUsrInfo;
	g_pMessengerActor->GetMyUserInfo(MyUsrInfo);
    CString myUsrID(MyUsrInfo.strUserID);
	std::vector<CSMSModel::SMSReceiverInfo>::iterator it = m_SMSModel.m_recentReceiverVector.begin();
	for (size_t i=0; i < list.nSize; i++)
	{

       const NE_MEMBER_DATA &sMemberInfo = list.pList[i];
     
	   for (	it = m_SMSModel.m_recentReceiverVector.begin();
		         it!=m_SMSModel.m_recentReceiverVector.end();it++)
	   {
		   if ((*it).strID.CompareNoCase(sMemberInfo.strUserId.c_str()) == 0)
		   {
			   (*it).strName = sMemberInfo.strName.c_str();
			   (*it).strCellPhone = sMemberInfo.strCellPhone.c_str();
		   }
		   else if (myUsrID.CompareNoCase(sMemberInfo.strUserId.c_str()) == 0)
		   {
               m_strMyCellPhone = sMemberInfo.strCellPhone.c_str();
			   m_pSMSSendWnd->SetSenderText();
		   }
	   }
	 
	}
	


	return true;

}



void CSMSController::RequestEmployeeInfoList(){

	const wchar_t* sperator = L"|";

	std::wstring listUserID;

	std::vector<CSMSModel::SMSReceiverInfo>::iterator it = m_SMSModel.m_recentReceiverVector.begin();

	for (;it!=m_SMSModel.m_recentReceiverVector.end();it++)
	{
		CSMSModel::SMSReceiverInfo info = *it;
		CString strUserID = info.strID;
		if (listUserID.find(strUserID) == -1)
		{
			if (listUserID.empty() == false)
			{
				listUserID.append(sperator);
			}
			listUserID.append(strUserID);
		}
       
	}
	GT_MY_USER_DATA MyUsrInfo;
	g_pMessengerActor->GetMyUserInfo(MyUsrInfo);
	CString myUsrID(MyUsrInfo.strUserID);

	if (listUserID.empty() == false)
	{
		listUserID.append(sperator);
	}
	listUserID.append(myUsrID);

	trid_t m_trid=0;
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);

	g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(listUserID.c_str(), GetLanguageStringUnicode(), reitSingleTrans, &m_trid);

}

int CSMSController::Load(void)
{
	CSingleLock lock(&m_csLock, TRUE);
	
	TCHAR buffer[128] = {0};	//temp buffer

	CString strPath;
	strPath.Format(_T("%s\\recentSmsRecv.dat"), GET_APP()->GetAppDataDir());

	CStdioFile file;
	if (file.Open(strPath, CFile::modeRead ) == 0)
	{
		return -1;
	}


	CString strLine; 
	while (file.ReadString(strLine))
	{
		int nFind = strLine.Find(_T(","));

		if (strLine.IsEmpty() || nFind == -1)
		{
			continue;
		}

		CString strID =strLine.Left(nFind);
		CString strTelNumber =strLine.Right(strLine.GetLength()-nFind-1);
        NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strID);
		CString strName =data.strName.c_str();
		CSMSModel::SMSReceiverInfo ri;
		ri.strID = strID;		
		strTelNumber.Remove('-');
		strTelNumber.Remove('+');
		if (L""==strTelNumber)
		{
			return FALSE;
		}

		ri.strCellPhone = strTelNumber;
		ri.strName = strName;
		if (std::find(m_SMSModel.m_recentReceiverVector.begin(), 
			m_SMSModel.m_recentReceiverVector.end(), ri) == m_SMSModel.m_recentReceiverVector.end())
		{
			m_SMSModel.m_recentReceiverVector.push_back(ri);			
		}	

	}  

	file.Close();
    RequestEmployeeInfoList();
	return 0;
}

void CSMSController::UpdateRecentSMSReceiver(){
  m_SMSModel.m_recentReceiverVector.clear();
  for( std::vector<CSMSModel::SMSReceiverInfo>::const_iterator iter = m_SMSModel.m_receiverVector.begin(); iter != m_SMSModel.m_receiverVector.end(); ++iter )
  {

	  m_SMSModel.m_recentReceiverVector.push_back(*iter);	 

  }
  m_SMSModel.m_receiverVector.clear();
  Save();
}